declare filename "blit_square.dsp"; declare name "blit_square"; ba = library("basics.lib");
ma = library("maths.lib");
//m2 = library("maths2.lib");
fi = library("filters.lib");
de = library("delays.lib");

// differentiator
diff(x) = x-x';

// Nyquist
ny = ma.SR/2;

// linear interpolation between samples
del_lin(size, del, in) = de.fdelay(size*ma.SR, del*ma.SR, in);

// phasor with phase reset
ph(freq, reset) = freq/ma.SR : (+ : ma.decimal) ~ *(1-(reset : !=(0)));

// first derivative
delta(s, t, in) = in, del_lin(s, t, in) : -;

// NAN-safe divider
div(x1, x2) = ba.if(x2 : ==(0), 0, (x1, x2 : /));

// unipolar BLIT
blit_up(f, h) = ba.if(phase : ==(0), 1, sinc)
with {
      sinc =   sin(phase*h_1), sin(phase) : div, h_1 : div;
      phase = ph(f_1, 0)*2*ma.PI;
      f_1 = f/2;
      h_1 = diff(phase) : <(0),
            (h*2+1 : min(lim) : int) : ba.sAndH;
      lim = ba.if((int((ma.SR, f : div)) : %(2) : ==(0)), int((ma.SR, f : div))-1, int((ma.SR, f : div)));
};

// bipolar BLIT
blit_bp(f, h, d) = delta(10, d1, blit_up(f, h))
with {
      d1 = d*( 1, f : div);
};

square(f, h) = blit_bp(f, h, .5) : fi.pole(1-10/ma.SR) : *(scale)
with {
      lim =    ny,
               f : div;
      scale =  (h : min(lim)), 
               lim : div;
};

f = hslider("freq", 135, 0.0001, 10000, 0.0001);
h = hslider("h", 5, 0.5, 100, 0.001);

process = square(f, h) : _;