declare filename "reverse_echo_12.dsp"; declare name "reverse_echo_12"; si = library("signals.lib");
ma = library("maths.lib");

NB = 12;
sec2samp = *(ma.SR);

np3(x) = pow(2, ceil(log(x)/log(2))); // next power of 2 of x

delay(n,d,x) = x @ min(n, max(0,d));

reverseDelayRamped(delMax,phs) = rampGain * delay(delMax,del) with {
    rampGain = 4 * (del/delMax) * (1 - del/delMax); // suppress click when delay-line wraps around
    delOffset = int(floor(0.5 + delMax * max(0,min(0.999999,phs)))); // starting point in delay line
    startPulse = (1-1') * delOffset;
    del = int(startPulse : +  ~ +(2)) & (delMax-1);
};

reverseEchoN(N,delMax) = (+: _<: par(i,N,reverseDelayRamped(delMax,i/N)) <: si.bus(NB*2))~(_,_,_,_,_,_,_,_,_,_,_,_,!,!,!,!,!,!,!,!,!,!,!,!:>_*(fback)) : !,!,!,!,!,!,!,!,!,!,!,!,_,_,_,_,_,_,_,_,_,_,_,_;

uniformPanToStereo(N) = si.bus(N) <: par(i,2*N,_) : (par(i,N,*(i/(N-1))) :> _), (par(i,N,*(1-i/(N-1))) :> _);

delMax = np3(sec2samp(hslider("delMax", 1000., 0.0001, 10000., 0.0001)/1000));
fback = hslider("feedback", 0.,0.,1.,0.0001)/NB:si.smoo;

process = reverseEchoN(NB,delMax):> uniformPanToStereo(NB) :> _,_ ;