declare filename "sdelay.dsp"; declare name "sdelay"; // sdelay: a mono delay that doesn't click and doesn't transpose when the delay time is changed.

ba = library("basics.lib");

delay(n,d,x) = x @ min(n, max(0,d));

interpolate(i) = *(1.0-i),*(i) : +;

sdelay(N, it, dt) = ctrl(it,dt),_ : ddi(N)
with {
	ddi(N, i, d0, d1) = _ <: delay(N,d0), delay(N,d1) : interpolate(i);

	ctrl(it, dt) = \(v,ip,d0,d1).((nv, nip, nd0, nd1)
	with {
		// interpolation variation
		nv = ba.if (v!=0.0,                         // if variation we are interpolating
			ba.if ((ip>0.0) & (ip<1.0), v, 0),      // should we continue or not ?
			ba.if ((ip==0.0) & (dt!=d0), 1.0/it,    // if true xfade from dl0 to dl1
			ba.if ((ip==1.0) & (dt!=d1), -1.0/it,   // if true xfade from dl1 to dl0
					 0)));                  		// nothing to change
		// interpolation value
		nip = ip+nv : min(1.0) : max(0.0);

		// update delay time of line 0 if needed
		nd0 = ba.if ((ip >= 1.0) & (d1!=dt), dt, d0);

		// update delay time of line 0 if needed
		nd1 = ba.if ((ip <= 0.0) & (d0!=dt), dt, d1);
	} ) ~ (_,_,_,_) : (!,_,_,_);
};

del = hslider("del", 0, 0., 441000.0, 1);
maxdel = hslider("maxdel", 44100, 0, 441000, 1);
interp = hslider("interp", 512, 0, 441000, 1);
clear = button("clear");

process = _: sdelay(maxdel,interp,del) : _;