declare filename "transistorBuffer.dsp"; declare name "transistorBuffer"; declare name "Transistor Buffer";
declare category "Guitar Effects";
declare shortname "Transistor Buffer";
declare description "Transistor Buffer";

// import("stdfaust.lib");

SR = 44100;

iir(bv,av) = sub ~ fir(av) : fir(bv);
sub(x,y) = y-x;

fir((b0,bv)) = _ <: *(b0), R(1,bv) :> _ with {
	R(n,(bn,bv)) = (@(n):*(bn)), R(n+1,bv);
	R(n, bn)     = (@(n):*(bn));              };
fir(b0) = *(b0);

smooth(s) = *(1.0 - s) : + ~ *(s);

process = pre : _<:*(dry),(*(wet) : iir((b0/a0,b1/a0),(a1/a0))):>_ with {
    LogPot(a, x) = ba.if(a, (exp(a * x) - 1) / (exp(a) - 1), x);
    Inverted(b, x) = ba.if(b, 1 - x, x);
    s = 0.993;
    fs = float(SR);
    pre = _;
    wet = hslider("wet_dry",  100, 0, 100, 1) : /(100) : smooth(0.999);
    dry = 1 - wet;
    b0 = 2.06312564351033e-5*fs;
    b1 = -2.06312564351033e-5*fs;
    a0 = 2.08132601776102e-5*fs + 0.000963511474709834;
    a1 = -2.08132601776102e-5*fs + 0.000963511474709834;
};